Class | ActiveRecord::ConnectionAdapters::ConnectionPool
In: | lib/active_record/connection_adapters/abstract/connection_pool.rb
Parent: | Object

Connection pool base class for managing ActiveRecord database connections.

## Introduction

A connection pool synchronizes thread access to a limited number of database connections. The basic idea is that each thread checks out a database connection from the pool, uses that connection, and checks the connection back in. ConnectionPool is completely thread-safe, and will ensure that a connection cannot be used by two threads at the same time, as long as ConnectionPool‘s contract is correctly followed. It will also handle cases in which there are more threads than connections: if all connections have been checked out, and a thread tries to checkout a connection anyway, then ConnectionPool will wait until some other thread has checked in a connection.

## Obtaining (checking out) a connection

Connections can be obtained and used from a connection pool in several ways:

1. Simply use ActiveRecord::Base.connection as with ActiveRecord 2.1 and earlier (pre-connection-pooling). Eventually, when you‘re done with the connection(s) and wish it to be returned to the pool, you call ActiveRecord::Base.clear_active_connections!. This will be the default behavior for ActiveRecord when used in conjunction with ActionPack‘s request handling cycle.
2. Manually check out a connection from the pool with ActiveRecord::Base.connection_pool.checkout. You are responsible for returning this connection to the pool when finished by calling ActiveRecord::Base.connection_pool.checkin(connection).
3. Use ActiveRecord::Base.connection_pool.with_connection(&block), which obtains a connection, yields it as the sole argument to the block, and returns it to the pool after the block completes.

Connections in the pool are actually AbstractAdapter objects (or objects compatible with AbstractAdapter‘s interface).

## Options

There are two connection-pooling-related options that you can add to your database connection configuration:

- `pool`: number indicating size of connection pool (default 5)
- `wait_timeout`: number of seconds to block and wait for a connection before giving up and raising a timeout error (default 5 seconds).

### Methods

checkin checkout clear_reloadable_connections! clear_stale_cached_connections! connected? connection disconnect! new release_connection with_connection

### Attributes

spec | [R] |

### Public Class methods

new(spec)

Creates a new ConnectionPool object. `spec` is a ConnectionSpecification object which describes database connection information (e.g. adapter, host name, username, password, etc), as well as the maximum size for this ConnectionPool.

The default ConnectionPool maximum size is 5.

### Public Instance methods

checkin(conn)

Check-in a database connection back into the pool, indicating that you no longer need this connection.

`conn`: an AbstractAdapter object, which was obtained by earlier by calling `checkout` on this pool.

checkout()

Check-out a database connection from the pool, indicating that you want to use it. You should call checkin when you no longer need this.

This is done by either returning an existing connection, or by creating a new connection. If the maximum number of connections for this pool has already been reached, but the pool is empty (i.e. they‘re all being used), then this method will wait until a thread has checked in a connection. The wait time is bounded however: if no connection can be checked out within the timeout specified for this pool, then a ConnectionTimeoutError exception will be raised.

Returns: an AbstractAdapter object.

Raises:

- ConnectionTimeoutError: no connection can be obtained from the pool within the timeout period.

clear_reloadable_connections!()

Clears the cache which maps classes

clear_stale_cached_connections!()

Return any checked-out connections back to the pool by threads that are no longer alive.

connected?()

Returns true if a connection has already been opened.

connection()

Retrieve the connection associated with the current thread, or call checkout to obtain one if necessary.

connection can be called any number of times; the connection is held in a hash keyed by the thread id.

disconnect!()

Disconnects all connections in the pool, and clears the pool.

release_connection()

Signal that the thread is finished with the current connection. release_connection releases the connection-thread association and returns the connection to the pool.

with_connection() {|conn| ...}

Reserve a connection, and yield it to a block. Ensure the connection is checked back in when finished.

[Validate]